//+------------------------------------------------------------------+
//|                                               ASC_Trend_1sig.mq4 |
//|                                              thanks to komposter |C0Rpus - big thanks CHANGE2002, STEPAN and SERSH
//|                                             komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "thanks to komposter"
#property link      "komposterius@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

extern double RISK = 3;
/*extern*/ double K = 0.5;

double buf0[]; //ASC_Trend_Up
double buf1[]; //ASC_Trend_Down

int init()
{
	IndicatorShortName( "ASC_Trend" );
	IndicatorDigits ( MarketInfo( Symbol(), MODE_DIGITS ) );

	SetIndexBuffer( 0 , buf0 );
	SetIndexStyle ( 0 , DRAW_ARROW , EMPTY , 1 );
	SetIndexArrow( 0 , 217);
	SetIndexDrawBegin( 0 , 12 );
	SetIndexLabel( 0 , "ASC_Trend_Up");

	SetIndexBuffer( 1 , buf1 );
	SetIndexStyle ( 1 , DRAW_ARROW , EMPTY , 1 );
	SetIndexArrow( 1 , 218);
	SetIndexDrawBegin( 1 , 12 );
	SetIndexLabel( 1 , "ASC_Trend_Down");

return(0);
}

int ASC_Trend_Prev = 1;

int start()
{
	int counted_bars=IndicatorCounted();
	if ( counted_bars < 0 ) { Print( "counted_bars < 0 !" ); return(-1); }
	if ( Bars < 100 ) { Print( "Bars < 100 !" ); return(-1); }
	if ( counted_bars > 0 ) { counted_bars -- ; }

   int limit = Bars - 12;
   if ( counted_bars > 0 ) { limit = Bars - counted_bars - 12; }

	double x1 = 67 + RISK, x2 = 33 - RISK;
	for ( int i = limit; i >= 0; i -- )
	{
		double ASC_Trend_Up = 0, ASC_Trend_Down = 0, SummRange = 0, AvgRange = 0;

		for ( int u = i + 9; u >= i; u -- )
		{ SummRange += High[u] - Low[u]; }
		AvgRange = SummRange / 10;

		int WprPeriod = 3 + RISK * 2;

		for ( u = i + 9; u >= i; u -- )
		{
			if ( MathAbs( Open[u] - Close[u+1] ) >= AvgRange * 2 )
			{ WprPeriod = 3; break; }
		}

		for ( u = i + 6; u >= i; u -- )
		{
			if ( MathAbs( Close[u+3] - Close[u] ) >= AvgRange * 4.6 )
			{ WprPeriod = 4; break; }
		}

		double WprAbs = 100 + iWPR( Symbol(), 0, WprPeriod, i );

		if ( WprAbs > x1 && ASC_Trend_Prev == -1 )
		{ ASC_Trend_Up = Low[i] - AvgRange * K; ASC_Trend_Prev = 1; }

		if ( WprAbs < x2 && ASC_Trend_Prev == 1 )
		{ ASC_Trend_Down = High[i] + AvgRange * K; ASC_Trend_Prev = -1; }

		buf0[i] = ASC_Trend_Up;
		buf1[i] = ASC_Trend_Down;
	}
return(0);
}


int deinit() { return(0); }
/*
 , -             500 ,      
    WPRfast   9,9,49.       
  ASCTrend1,    . 
    ASCTrend1sig      .     
 , ..    .           ,  : 
  -  ,    William`s Percent Range   -30%      
 9. 
  -  ,    William`s Percent Range   -70%      
 9 
       .      .  , 
   , ..     L-ATR*0.5,   L-ATR*. (  ). 
   BTstop.     NRTR.         
 -   .  BTstop  NRTR    ,   , 
       ATR ,      
 NRTR (  ) .        ,   ,   
  . 

   .        WPR     (ASCTrend1   
 WPR). ,   William`s Percent Range ? -       N-, 
    ,   %    .  ,  ,    
 =0%,    = - 100%.       -30%  -70%.    -30% - , 
  -70% - . 
            -     .   , 
     ASCTrend .    ,    . 

[[ 
Name := Silver-channel 
Author := Copyright  2003, VIAC.RU AlexSilver 
Link := http://viac.ru/ 
Separate Window := No 
First Color := Red 
First Draw Type := Line 
Use Second Data := Yes 
Second Color := Blue 
Second Draw Type := Line 
Second Symbol := 218 
]]
Inputs : Kmin(30), Kmax(30),SSP(9); 
Variables : shift(0), cnt(0), loopbegin(0); 
Variables : smin(0), smax(0), SsMax(0), SsMin(0); 

SetLoopCount(0); 

// moving average 
loopbegin = Bars-1; 
For shift = loopbegin Downto 0 Begin 
SsMax = High[Highest(MODE_HIGH,shift,SSP)]; 
SsMin = Low[Lowest(MODE_LOW,shift,SSP)]; 
smin = SsMin+(SsMax-SsMin)*Kmin/100; 
smax = SsMax-(SsMax-SsMin)*Kmax/100; 
SetIndexValue(shift-SSP+1,smin); 
SetIndexValue2(shift-SSP+1,smax); 
loopbegin = loopbegin-1; 
End; 


 Kmin(30), Kmax(30) - %       .    -30%  -70%. 

, ,   .  , - ,   .

/////////////////////////////////////////////////////////////////////////////

  AscTrend -     SilverTrend:

/*[[ 
Name := SilverTrend
Author := Copyright  2003, VIAC.RU AlexSilver,OlegVS,GOODMAN
Link := http://viac.ru/ 
Separate Window := No 
First Color := Red 
First Draw Type := Histogram 
Use Second Data := Yes 
Second Color := Blue
Second Draw Type := Histogram 
Second Symbol := 218 
]]
Inputs : RISK(3),SSP(9); 
Variables : shift(0), cnt(0), loopbegin(0); 
Variables : smin(0), smax(0), SsMax(0), SsMin(0) ,K(0),val1(0),val2(0); 

SetLoopCount(0); 

K=33-RISK;
loopbegin = Bars-1; 
For shift = loopbegin Downto 0 Begin 
SsMax = High[Highest(MODE_HIGH,shift,SSP)]; 
SsMin = Low[Lowest(MODE_LOW,shift,SSP)]; 
smin = SsMin+(SsMax-SsMin)*K/100; 
smax = SsMax-(SsMax-SsMin)*K/100; 
val1=0;
val2=0;
If C[shift-SSP+1]<smin Then
{val1=High[shift-SSP+1];
val2=Low[shift-SSP+1];
};
If C[shift-SSP+1]>smax Then
{val2=High[shift-SSP+1];
val1=Low[shift-SSP+1];
};

SetIndexValue(shift-SSP+1,val1); 
SetIndexValue2(shift-SSP+1,val2); 
loopbegin = loopbegin-1; 
End;